;  ..  2005.
; a_biv @ list . ru    

	list      p=16f628            ; list directive to define processor
	#include <p16f628.inc>        ; processor specific variable definitions
	__CONFIG _CP_OFF & _WDT_OFF & _BODEN_ON & _PWRTE_ON & _HS_OSC & _MCLRE_OFF & _LVP_OFF
;**********************************************************************
#define     L_Clk       PORTB,1   ; 
#define     L_Data      PORTB,2   ; 
#define     TPGate      PORTA,3   ; 
#define     _RP0        STATUS,RP0
#define     _RP1        STATUS,RP1
#define     _GIE        INTCON,GIE
;***** VARIABLE DEFINITIONS
	cblock	   0x20
		Lcd0	; 
		Lcd1,Lcd2,Lcd3,Lcd4,Lcd5,Lcd6,Lcd7,Lcd8
		Lcd9	; 
		Count1,Count2	;     BIN2LCD
		Count_Fin0,Count_Fin1,Count_Fin2,Count_Fin3 ;  
		OverTMR1         ;   TMR1
		Buf_LCD_0,Buf_LCD_1,Buf_LCD_2,Buf_LCD_3	;   LCD
	endc
;------------------------------------------
     cblock  0x70       ;     - 16 .
    W_Temp,Status_Temp ;     
	Flags				;  .
      endc
; Flags :  :
NZero		equ		0x00	;  0 -    
;**********************************************************************
		ORG     0x0000
		goto	Init
;---------------------------------------------------------------
		ORG     0x0004
		movwf	W_Temp
		swapf	STATUS,w
		movwf	Status_Temp
		;   ----------------------------------
	  clrf   PIR1	;   
	  decfsz OverTMR1,f		; DEC   
	  goto	GoOutInt  		;  2 
      nop	; 
      nop
      nop
      nop
      nop
      nop
      bsf  	_RP0              ;  !
      bcf   TPGate ;   TRIS` -  .
      bcf   _RP0
      bcf   T1CON,TMR1ON	;  TMR1
      btfss INTCON,T0IF    ;    TMR0
      goto  FmT0_0
      bcf   INTCON,T0IF
      incf  Count_Fin2,f
	  btfsc	STATUS,Z
      incf  Count_Fin3,f
FmT0_0
	  movfw	TMR0		;  TMR0
	  movwf	Count_Fin1
	;  ''''''''''''''''''''''''''''''''''''
UpCount
		incf	Count_Fin0,f
		bcf		TPGate ;  "0".
		nop
		bsf		TPGate ;  "1".
		nop
		movf	TMR0,w
		bcf		STATUS,Z
		subwf	Count_Fin1,w	;    
		btfsc	STATUS,Z		;   TMR0
		goto	UpCount
		incf	Count_Fin0,f
		comf	Count_Fin0,f
		incf	Count_Fin0,f
		incf	Count_Fin0,f
	    bcf		INTCON,T0IF
	; '''''''''''''''''''''''''''''''''''''''''''''
	  call	Bin2LCD		;    
	  call	CorrZero	;  
	  call	MoveDig		;      
	  call	LCD_Out		;   
	  goto	Main				;  .
GoOutInt	;   -------------------------
	    swapf	Status_Temp,w
		movwf	STATUS
		swapf	W_Temp,f
		swapf	W_Temp,w
		retfie
;******************************************************************
Init   ; -------------------  
		movlw  	B'01000000'
		movwf	INTCON
		bsf		_RP0
		movlw  	B'00000001'	
		movwf	PIE1		;   TMR1
		movlw  	B'11111111'
       	movwf	TRISA
		movlw  	B'111111001'	;     RB1  RB2
       	movwf	TRISB
		movlw  	B'00110111'	; TMR0 - /256,   T0CKI
       	movwf	OPTION_REG	; TMR0 c    
		bcf		_RP0		
		clrf	STATUS	  ;     
		clrf	PORTA 
		clrf	PORTB
        movlw 	b'00110000'	;   
        movwf 	T1CON		; TMR1 /8 -  : Fosc/4
		movlw	B'00000111'
		movwf	CMCON		;  
      	movlw 	0x20  ;-----------       
      	movwf 	FSR
ClearReg
      	clrf  	INDF
      	incf  	FSR,f
      	btfss 	FSR,7
      	goto  	ClearReg
;************************************************************************
Main
	  bsf	TPGate ;  "1".
      bsf   _RP0
      bcf   TPGate ;   TRIS` -  .
      bcf   _RP0
      movlw 0x17        ; 
      movwf TMR1H
      movlw 0xBA
      movwf TMR1L
      movlw 0x02
      movwf OverTMR1    ; 2   1 
      clrf  TMR0
      clrf  Count_Fin0	;   
      clrf  Count_Fin1
      clrf  Count_Fin2
      clrf  Count_Fin3
      clrf  Lcd0
      clrf  Lcd1
      clrf  Lcd2
      clrf  Lcd3
      clrf  Lcd4
      clrf  Lcd5
      clrf  Lcd6
      clrf  Lcd7
      clrf  Lcd8
      clrf  Lcd9
	  bsf	_GIE		;  
      bsf   T1CON,TMR1ON       ;  !
      bsf   _RP0      ;  
      bsf   TPGate ;   TRIS` -  .
      bcf   _RP0
FreqMeterLoop   ;     TMR0
      btfss INTCON,T0IF
      goto  FreqMeterLoop
      bcf   INTCON,T0IF
      incf  Count_Fin2,f
	  btfsc	STATUS,Z
      incf  Count_Fin3,f
	  goto	FreqMeterLoop
;=============================================
;     LCD
Bin2LCD
		movfw	Count_Fin0	;   
		movwf	Buf_LCD_0
		movfw	Count_Fin1
		movwf	Buf_LCD_1
		movfw	Count_Fin2
		movwf	Buf_LCD_2
		movfw	Count_Fin3
		movwf	Buf_LCD_3
      bcf   STATUS,0        ; clear the carry bit
      movlw .32
      movwf Count2     ; Count2:= 32
	  clrf	Lcd4      ; .
      clrf  Lcd3      ;  .
      clrf  Lcd2
      clrf  Lcd1
      clrf  Lcd0      ; .
loop16
      rlf   Buf_LCD_0,f      ; .  
      rlf   Buf_LCD_1,f
      rlf   Buf_LCD_2,f
      rlf   Buf_LCD_3,f      ; .
      rlf   Lcd0,f     		   ;    CF
      rlf   Lcd1,f
      rlf   Lcd2,f
      rlf   Lcd3,f
      rlf   Lcd4,f
      decfsz Count2,f   ;Count:=Count-1,if Count=0 then skip next cmd
      goto  adjDEC
      movfw Lcd4    		   ; w:= Lcd3
      andlw 0Fh     		   ;  -> w, w-> AND `00001111`
      movwf Lcd8    		   ; Lcd6:=w
      swapf Lcd3,w  		   ;   Lcd3  
      andlw 0Fh     		   ;  -> w, w-> AND `00001111`
      movwf Lcd7    		   ; Lcd7:=w
      movfw Lcd3    		   ; w:= Lcd3
      andlw 0Fh     		   ;  -> w, w-> AND `00001111`
      movwf Lcd6    		   ; Lcd6:=w
      swapf Lcd2,w  		   ;   Lcd2  
      andlw 0Fh     		   ;  -> w, w-> AND `00001111`
      movwf Lcd5    		   ; Lcd5:=w
      movfw Lcd2    		   ; w:= Lcd2
      andlw 0Fh     		   ;  -> w, w-> AND `00001111`
      movwf Lcd4    		   ; Lcd4:=w
      swapf Lcd1,w  		   ;   Lcd1  
      andlw 0Fh     		   ;  -> w, w-> AND `00001111`
      movwf Lcd3    		   ; Lcd3:=w
      movfw Lcd1    		   ; w:= Lcd1
      andlw 0Fh     		   ;  -> w, w-> AND `00001111`
      movwf Lcd2    		   ; Lcd2:=w
      swapf Lcd0,w  		   ;   Lcd0  
      andlw 0Fh     		   ;  -> w, w-> AND `00001111`
      movwf Lcd1    		   ; Lcd1:=w
      movfw Lcd0    		   ; w:= Lcd0
      andlw 0Fh     		   ;  -> w, w-> AND `00001111`
      movwf Lcd0    		   ; Lcd0:=w
      return
adjDEC
      movlw Lcd0    		   ; w:= `H Lcd0`
      movwf FSR     		   ; FSR:= w
      call  adjBCD
      movlw Lcd1   		   ; w:= `H Lcd1`
      movwf FSR     		   ; FSR:= w
      call  adjBCD
      movlw Lcd2    		   ; w:= `H Lcd2`
      movwf FSR     		   ; FSR:= w
      call  adjBCD
      movlw Lcd3    		   ; w:= `H Lcd3`
      movwf FSR     		   ; FSR:= w
      call  adjBCD
      goto  loop16
adjBCD
      movlw 3         		   ; w:= 3
      addwf INDF,w    		   ; w:= IndF + 3
      movwf Count1  	   ; Count1:= w
      btfsc Count1,3  	   ; test if result > 7
      movwf INDF      		   ; IndF:= w
      movlw 30        		   ; w:= 30
      addwf INDF,w     		   ; w:= IndF + 30
      movwf Count1    	   ; Count1:= w
      btfsc Count1,7  	   ; test if result > 7
      movwf INDF       		   ; save as MSD, IndF:= w
      retlw 0         		   ; w:= 0
;*************************************************************************
MoveDig	;     ,   .
		movfw	Lcd7
		movwf	Lcd9
		movfw	Lcd6
		movwf	Lcd8
		movfw	Lcd5
		movwf	Lcd6
		movfw	Lcd4
		movwf	Lcd5
		movfw	Lcd3
		movwf	Lcd4
		clrf	Lcd7
		clrf	Lcd3
		return
;*************************************************************************
CorrZero	;      .
		bcf		Flags,NZero
		movlw 	Lcd9 	; p  p p
		movwf 	FSR
CorrZ_Ret
		movf	INDF,w
		btfss	STATUS,Z
		goto	CorrZ_Ret_5	;  0
		btfss	Flags,NZero	; 0  ?
		goto	CorrZ_Ret_4	; 0   -    -   
		movlw	0x0A	;  "0" - 00
		movwf	INDF
CorrZ_Ret_5
		bsf		Flags,NZero	;  0 .
		;--------------------
CorrZ_Ret_4
		decf	FSR,f
		movlw	Lcd0
		subwf	FSR,w
		BNZ		CorrZ_Ret
		movf	Lcd0,w		;  0  
		btfss	STATUS,Z
		return
		movlw	0x0A	; "0" 
		movwf	Lcd0
     	return
;*************************************************************************
LCD_Out
		movlw 	Lcd9 	; p  p p
		movwf 	FSR
it03 	bsf 	L_Clk
		bsf 	L_Data	; . L_Data & L_Clk
		btfss 	INDF,3 	;  1-  
		bcf 	L_Data 	;   0 - 
		goto 	$+1
		bcf		L_Clk 	;   
		goto	$+1
		goto	$+1
		bsf 	L_Clk
		bsf 	L_Data 	; . L_Data & L_Clk
		btfss 	INDF,2 	;  2-  
		bcf 	L_Data 	;   0 - 
		goto 	$+1
		bcf 	L_Clk 	;   
		goto	$+1
		goto 	$+1
		bsf 	L_Clk
		bsf		L_Data 	; . L_Data & L_Clk
		btfss 	INDF,1 	;  3-  
		bcf 	L_Data 	;   0 - 
		goto 	$+1
		bcf 	L_Clk 	;   
		goto 	$+1
		goto 	$+1
		bsf 	L_Clk
		bsf 	L_Data 	; . L_Data & L_Clk
		btfss 	INDF,0 	;  4-  
		bcf 	L_Data 	;   0 - 
		goto 	$+1
		bcf 	L_Clk 	;   
		goto 	$+1
		goto 	$+1
		decf 	FSR,f
		movlw	Lcd0 - 1
		subwf	FSR,w
		BNZ		it03 	;  
		bcf 	L_Data
		return
;*************************************************************************
		END                       ; end of program
